> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List Workflow Execution Actions

> Lists workflow execution actions with optional filtering.

`Unary` · [`Workflows`](https://ona.com/docs/api-reference/generated/workflow/overview)

Lists workflow execution actions with optional filtering.

Use this method to:

* Monitor individual action execution status
* Debug action failures
* Track resource usage per action

### Examples

* List execution actions for workflow execution:

  Shows all execution actions for a specific workflow execution.

  ```yaml theme={null}
  filter:
    workflowExecutionIds: ["d2c94c27-3b76-4a42-b88c-95a85e392c68"]
  pagination:
    pageSize: 20
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.WorkflowService/ListWorkflowExecutionActions
```

Send a Bearer token as described in [Authentication](https://ona.com/docs/api-reference.md#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

```bash cURL theme={null}
export ONA_HOST=https://app.ona.com
export ONA_API_KEY=<your-token>

curl --request POST \
  --url "$ONA_HOST/api/gitpod.v1.WorkflowService/ListWorkflowExecutionActions" \
  --header "Authorization: Bearer $ONA_API_KEY" \
  --header "Content-Type: application/json" \
  --data '{
  "pagination": {
    "pageSize": 1
  }
}'
```

```python Python theme={null}
import gitpod.v1.pagination_pb2 as pagination_pb2
import gitpod.v1.workflow_pb2 as workflow_pb2
from ona_sdk import create_client_from_env

ona = create_client_from_env()
request = workflow_pb2.ListWorkflowExecutionActionsRequest(
    pagination=pagination_pb2.PaginationRequest(
        page_size=1,
    ),
)
response = ona.services.workflow.list_workflow_execution_actions(request)
print(response)
```

```typescript TypeScript theme={null}
import { create } from "@bufbuild/protobuf";
import { createClientFromEnv } from "@gitpod/sdk";
import { ListWorkflowExecutionActionsRequestSchema } from "@gitpod/sdk/gitpod/v1/workflow_pb";

async function main() {
  const ona = createClientFromEnv();
  const request = create(ListWorkflowExecutionActionsRequestSchema, {
    pagination: {
      pageSize: 1,
    },
  });
  const response = await ona.services.workflow.listWorkflowExecutionActions(request);
  console.log(response);
}

main().catch(console.error);
```

```go Go theme={null}
package main

import (
	"context"
	"fmt"
	"log"

	"connectrpc.com/connect"
	"github.com/gitpod-io/gitpod-sdk-go/sdk"
	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
)

func main() {
	ona, err := sdk.NewFromEnv()
	if err != nil {
		log.Fatal(err)
	}

	request := connect.NewRequest(&gitpodpb.ListWorkflowExecutionActionsRequest{
		Pagination: &gitpodpb.PaginationRequest{
			PageSize: 1,
		},
	})
	response, err := ona.Services.Workflow.ListWorkflowExecutionActions(context.Background(), request)
	if err != nil {
		log.Fatal(err)
	}
	fmt.Println(response.Msg)
}
```

```json Request body theme={null}
{
  "pagination": {
    "pageSize": 1
  }
}
```

## Request

`gitpod.v1.ListWorkflowExecutionActionsRequest`

ListWorkflowExecutionActionsRequest lists workflow execution actions with optional filtering.

| Field | Type | Required | Description |
| - | - | - | - |
| `pagination` | [PaginationRequest](#type-gitpod-v1-pagination-request) | No | |
| `filter` | [Filter](#type-gitpod-v1-list-workflow-execution-actions-request-filter) | No | |

## Response

`gitpod.v1.ListWorkflowExecutionActionsResponse`

| Field | Type | Required | Description |
| - | - | - | - |
| `pagination` | [PaginationResponse](#type-gitpod-v1-pagination-response) | No | |
| `workflowExecutionActions` | array of [WorkflowExecutionAction](#type-gitpod-v1-workflow-execution-action) | No | |

## Related types

> [accordion] Filter
>
> `gitpod.v1.ListWorkflowExecutionActionsRequest.Filter`
>
> | Field | Type | Required | Description |
> | - | - | - | - |
> | `workflowExecutionActionIds` | array of string | No | Constraints: `repeated.items.string.uuid=true, repeated.max_items=25`. |
> | `workflowExecutionIds` | array of string | No | Constraints: `repeated.items.string.uuid=true, repeated.max_items=25`. |
> | `workflowIds` | array of string | No | Constraints: `repeated.items.string.uuid=true, repeated.max_items=25`. |
> | `phases` | array of [WorkflowExecutionActionPhase](#enum-gitpod-v1-workflow-execution-action-phase) | No | Constraints: `repeated.max_items=10`. |

> [accordion] PaginationRequest
>
> `gitpod.v1.PaginationRequest`
>
> | Field | Type | Required | Description |
> | - | - | - | - |
> | `pageSize` | integer | No | Page size is the maximum number of results to retrieve per page. Defaults to 25. Maximum 100. Constraints: `int32.gte=0, int32.lte=100`. |
> | `token` | string | No | Token for the next set of results that was returned as next\_token of a PaginationResponse |

> [accordion] PaginationResponse
>
> `gitpod.v1.PaginationResponse`
>
> | Field | Type | Required | Description |
> | - | - | - | - |
> | `nextToken` | string | No | Token passed for retrieving the next set of results. Empty if there are no more results |

> [accordion] WorkflowExecutionAction
>
> WorkflowExecutionAction represents a workflow execution action instance.
>
> `gitpod.v1.WorkflowExecutionAction`
>
> | Field | Type | Required | Description |
> | - | - | - | - |
> | `id` | string | No | Constraints: `string.uuid=true`. |
> | `metadata` | [Metadata](#type-gitpod-v1-workflow-execution-action-metadata) | No | |
> | `spec` | [Spec](#type-gitpod-v1-workflow-execution-action-spec) | No | |
> | `status` | [Status](#type-gitpod-v1-workflow-execution-action-status) | No | |

> [accordion] Metadata
>
> WorkflowExecutionActionMetadata contains workflow execution action metadata.
>
> `gitpod.v1.WorkflowExecutionAction.Metadata`
>
> | Field | Type | Required | Description |
> | - | - | - | - |
> | `workflowExecutionId` | string | No | Constraints: `string.uuid=true`. |
> | `workflowId` | string | No | Constraints: `string.uuid=true`. |
> | `startedAt` | RFC 3339 timestamp | No | |
> | `finishedAt` | RFC 3339 timestamp | No | |
> | `actionName` | string | No | Human-readable name for this action based on its context. Examples: "gitpod-io/gitpod-next" for repository context, "My Project" for project context. Will be empty string for actions created before this field was added. |

> [accordion] Spec
>
> WorkflowExecutionActionSpec contains the specification for this execution action.
>
> `gitpod.v1.WorkflowExecutionAction.Spec`
>
> | Field | Type | Required | Description |
> | - | - | - | - |
> | `session` | string | No | |
> | `desiredPhase` | [WorkflowExecutionActionPhase](#enum-gitpod-v1-workflow-execution-action-phase) | No | |
> | `context` | AgentCodeContext | No | Context for the execution action - specifies where and how the action executes. This is resolved from the workflow trigger context and contains the specific project, repository, or agent context for this execution instance. |
> | `limits` | PerExecution | No | |

> [accordion] Status
>
> WorkflowExecutionActionStatus contains the current status of a workflow execution action.
>
> `gitpod.v1.WorkflowExecutionAction.Status`
>
> | Field | Type | Required | Description |
> | - | - | - | - |
> | `session` | string | No | |
> | `phase` | [WorkflowExecutionActionPhase](#enum-gitpod-v1-workflow-execution-action-phase) | No | |
> | `stepStatuses` | array of StepStatus | No | Step-level progress tracking |
> | `environmentId` | string | No | Constraints: `ignore=1, string.uuid=true`. |
> | `agentExecutionId` | string | No | |
> | `failureMessage` | string | No | **Deprecated.** FailureMessage summarises why the workflow execution action failed to operate. If this is non-empty the workflow execution action has failed to operate and will likely transition to a stopped state. Deprecated: Use failures instead for structured error information. |
> | `warningMessage` | string | No | **Deprecated.** WarningMessage summarises why the workflow execution action is in a warning state. If this is non-empty the workflow execution action is in a warning state and likely does not match the users expectations. Deprecated: Use warnings field instead for structured warning information. |
> | `failures` | array of WorkflowError | No | Structured failures that caused the workflow execution action to fail. Provides detailed error codes, messages, and retry information. |
> | `warnings` | array of WorkflowError | No | Structured warnings about the workflow execution action. Provides detailed warning codes and messages. |

> [accordion] WorkflowExecutionActionPhase
>
> WorkflowExecutionActionPhase defines the phases of workflow execution action.
>
> | Value | Number | Description |
> | - | -: | - |
> | `WORKFLOW_EXECUTION_ACTION_PHASE_UNSPECIFIED` | 0 | |
> | `WORKFLOW_EXECUTION_ACTION_PHASE_PENDING` | 1 | |
> | `WORKFLOW_EXECUTION_ACTION_PHASE_RUNNING` | 2 | |
> | `WORKFLOW_EXECUTION_ACTION_PHASE_STOPPING` | 3 | |
> | `WORKFLOW_EXECUTION_ACTION_PHASE_STOPPED` | 4 | |
> | `WORKFLOW_EXECUTION_ACTION_PHASE_DELETING` | 5 | |
> | `WORKFLOW_EXECUTION_ACTION_PHASE_DELETED` | 6 | |
> | `WORKFLOW_EXECUTION_ACTION_PHASE_DONE` | 7 | |


This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.